<template>
  <BasicModal v-bind="$attrs" @register="registerModal" destroyOnClose :title="title" :width="800" @ok="handleSubmit">
      <BasicForm v-show="isDetail" @register="registerForm"/>
      <ActCheckbox v-show="!isDetail" :actCheckbox="actCheckbox"/>
  </BasicModal>
</template>

<script lang="ts" setup>
    import { message } from 'ant-design-vue';
import { computed, ref, unref } from 'vue';
import ActCheckbox from '../../components/ActCheckbox.vue';
import { saveOrUpdate } from '../StCaMainRelCollection.api';
import { formSchema } from '../StCaMainRelCollection.data';
import { BasicForm, useForm } from '/@/components/Form/index';
import { BasicModal, useModalInner } from '/@/components/Modal';
    // Emits声明
    const emit = defineEmits(['register','success']);
    const isUpdate = ref(true);
    const actCheckbox = ref({});
    const collectionNo = ref('');
    const isDetail = ref(false);
    //表单配置
    const [registerForm, {setProps,resetFields, setFieldsValue, validate}] = useForm({
        //labelWidth: 150,
        schemas: formSchema,
        showActionButtonGroup: false,
        baseColProps: {span: 24}
    });
    //表单赋值
    const [registerModal, {setModalProps, closeModal}] = useModalInner(async (data) => {
        //重置表单
        await resetFields();
        setModalProps({confirmLoading: false,showCancelBtn:!!data?.showFooter,showOkBtn:!!data?.showFooter});
        isUpdate.value = !!data?.isUpdate;
        collectionNo.value = data?.collectionNo
        isDetail.value = !data?.showFooter
        console.log(data)
        if (unref(isUpdate)) {
            //表单赋值
            await setFieldsValue({
                ...data.record,
            });
        }
        // 隐藏底部时禁用整个表单
       setProps({ disabled: !data?.showFooter })
    });
    //设置标题
    const title = computed(() => (!unref(isUpdate) ? '添加控制活动' : (unref(isDetail)?'查看控制活动':'修改控制活动')));
    //表单提交事件
    async function handleSubmit(v) {
        try {
            let values = await validate();
            console.log(collectionNo.value)
            if(!collectionNo.value){
                message.error("集合信息不存在，请检查")
                return;
            }
            values['collectionNo'] = collectionNo.value;
            let caNos = []
             for(let key in actCheckbox.value){
                if(actCheckbox.value[key]){
                    caNos.push(key)
                }
             }
             if(!caNos || caNos.length==0){
                message.error("请选择控制活动!")
                return;
            }
             values['caNos'] = caNos;
            setModalProps({confirmLoading: true});
            //提交表单
            await saveOrUpdate(values, isUpdate.value);
            //关闭弹窗
            closeModal();
            //刷新列表
            emit('success');
        } finally {
            setModalProps({confirmLoading: false});
        }
    }
</script>

<style lang="less" scoped>
	/** 时间和数字输入框样式 */
  :deep(.ant-input-number){
		width: 100%
	}

	:deep(.ant-calendar-picker){
		width: 100%
	}
</style>